import React, { ReactNode, ReactElement } from "react";
import { UntypedEntity, World, Query, QueriedEntity } from ".";
import { IEntity } from "./World";
export declare function createECS<TEntity extends IEntity = UntypedEntity>(): {
    world: World<TEntity>;
    useArchetype: (...query: Query<TEntity>) => import("./Archetype").Archetype<TEntity, Query<TEntity>>;
    useEntity: () => TEntity;
    Entity: React.FC<{
        children?: React.ReactNode | ((entity: TEntity) => JSX.Element);
        entity?: TEntity | undefined;
    }>;
    Component: <K extends keyof TEntity>(props: {
        name: K;
    } & ({
        data: TEntity[K];
    } | {
        children: React.ReactElement<any, string | React.JSXElementConstructor<any>> | ((entity: TEntity) => ReactElement);
    })) => JSX.Element;
    MemoizedEntity: React.FC<{
        entity: TEntity;
    }>;
    Entities: React.FC<{
        children: React.ReactNode | ((entity: TEntity) => JSX.Element);
        entities: TEntity[];
        memoize?: boolean | undefined;
    }>;
    Collection: <TTag extends keyof TEntity>({ initial, memoize, tag, children }: {
        children: React.ReactNode | ((entity: QueriedEntity<TEntity, [TTag]>) => JSX.Element);
        initial?: number | undefined;
        tag: TTag;
        memoize?: boolean | undefined;
    }) => JSX.Element;
};
